


        ;last work



        INDIBOXES_ADDRESS         EQU    02AH
        NUMBER_OF_USED_BOXES      EQU    018H
        NEXT_BOXES_ARE_FREE       EQU    039H
        NUMBER_OF_SIGNALS_PER_DAY EQU    036     ;DEC
        USED_BOXES_ADDRESS        EQU    020H
        CONSTANTA                 EQU    49995

        FIFTIES                   DATA   025H
        SECONDS                   DATA   026H
        MINUTES                   DATA   027H
        HOURS                     DATA   028H
        DAYS                      DATA   029H
        IND0                      DATA   02AH
        IND1                      DATA   02BH
        IND2                      DATA   02CH
        IND3                      DATA   02DH

        YET_CRY_OR_NOT            DATA   02EH
        DATAOUT                   DATA   02FH
        DIGIT_SELECTOR            DATA   030H
        DATAVIZOR                 DATA   031H
        BLOCK2K                   DATA   032H
        S_HOURS                   DATA   033H
        S_MINUTES                 DATA   034H
        LAST                      DATA   035H
        DURATION                  DATA   036H
        BUFFER                    DATA   037H
        LIMITER                   DATA   038H

        MODE                      DATA   020H
        FLAGER                    DATA   021H

        SIGNAL_LINE               BIT    P3.1
        RETURN_KEYS_LINE          BIT    P3.2
        SCL                       BIT    P3.0
        SDA                       BIT    P3.7

        MINUTES_CHANGED           BIT    023H.0
        HOURS_CHANGED             BIT    021H.0
        DAYS_CHANGED              BIT    021H.1
        FLASH_POINT               BIT    022H.0
        SET_MIN                   BIT    022H.1
        SET_HOUR                  BIT    022H.2
        SET_DW                    BIT    022H.3
        SET_FLAG                  BIT    022H.4
        FIRST                     BIT    022H.5
        DARK_OF_THE_SUN           BIT    022H.6
        CONTACT                   BIT    022H.7
        HOURS_EMPTY               BIT    023H.1
        MINUTES_EMPTY             BIT    023H.2
        FIRST_PRESS               BIT    023H.3
        DESPERATE_CRY             BIT    023H.4
        CLR_FLAG                  BIT    023H.5
        INVALID                   BIT    023H.6

        SLV_ADDR                  EQU    0101B
        ACK_READ                  EQU    10000101B
        FIRSTBLOCK                EQU    000B
        SECONDBLOCK               EQU    100B

;FINALY PROJECT WITH ALL DETAILS


                ORG     0000H
                LJMP    BEGINNING

                ORG     000BH
                LJMP    TIMES_UP



;************** MAIN PROGRAM *******************
BEGINNING:
                CLR     SDA
                CLR     SIGNAL_LINE
                CLR     DESPERATE_CRY
                CLR     CLR_FLAG
                CLR     INVALID

                MOV     IE,#082H
                MOV     R1,#NUMBER_OF_USED_BOXES
                MOV     R0,#USED_BOXES_ADDRESS
DIGGING_START:
                MOV     @R0,#000H
                INC     R0
                DJNZ    R1,DIGGING_START

                MOV     SP,#NEXT_BOXES_ARE_FREE
                MOV     TMOD,#001H
                MOV     TH0,#066H
                MOV     DPTR,#SEGMENTIC_CODES_ADDRESS
                SETB    TCON.4
                CLR     SET_FLAG
                CLR     FIRST
                MOV     FLAGER,#000H
                MOV     DAYS,#001H
                MOV     IND3,#010H              ;NOT INDICATE HIGH DIGIT

LOOPED_INDICATION_ROUTINE:

                MOV     R0,#INDIBOXES_ADDRESS
                MOV     DIGIT_SELECTOR,#080H
                MOV     R2,#004H
ONE_DIGIT_SHOWING:

                MOV     A,@R0
                MOVC    A,@A+DPTR
POINT_FLASHING:
                JNB     FLASH_POINT,NO_FLASH_POINT
                ORL     A,#001H
NO_FLASH_POINT:
                MOV     P1,A
                MOV     A,DIGIT_SELECTOR
                ANL     P3,#003H
FLASHING_ROUTINE:
                JNB     DARK_OF_THE_SUN,NOT_FLASHING
                JNB     SET_HOUR,HOUR_NOT_FLASH
                CJNE    A,#010H,PRE_OLDIER_OK
                SJMP    DIGIT_ACTIVED
PRE_OLDIER_OK:
                CJNE    A,#008H,HOUR_NOT_FLASH
                SJMP    DIGIT_ACTIVED
HOUR_NOT_FLASH:
                JNB     SET_MIN,NOT_FLASHING
                CJNE    A,#080H,LOWER_OK
                SJMP    DIGIT_ACTIVED
LOWER_OK:
                CJNE    A,#020H,NOT_FLASHING
                SJMP    DIGIT_ACTIVED
NOT_FLASHING:
                ORL     P3,A
                JNB     DESPERATE_CRY,DIGIT_ACTIVED
                SETB    SIGNAL_LINE
DIGIT_ACTIVED:
                CJNE    A,#080H,SHIFT_SELECTOR
                RR      A                       ;SKIP LINE P3.6
SHIFT_SELECTOR:
                RR      A
                MOV     DIGIT_SELECTOR,A
                INC     R0
                DJNZ    R6,KEEP_OLD
                CPL     DARK_OF_THE_SUN
KEEP_OLD:
                JNB     CONTACT,LET_S_CALL
                DJNZ    R5,DELAY_FOR_LIGHTING
LET_S_CALL:
                JB      DESPERATE_CRY,DELAY_FOR_LIGHTING
                PUSH    P3
                MOV     P3,#004h
                JB      RETURN_KEYS_LINE,NOT_PRESSALL
                POP     P3
                SJMP    KEY_IS_PRESSED
NOT_PRESSALL:
                POP     P3
                SJMP    DELAY_FOR_LIGHTING
KEY_IS_PRESSED:
                LCALL   KEYBOARD_OVERDRIVE

DELAY_FOR_LIGHTING:
                MOV     R3,#020H  ;EARLIE WAS 10H
EXTERNAL_LOOP:  MOV     R4,#015H
INTERNAL_LOOP:  DJNZ    R4,INTERNAL_LOOP
                DJNZ    R3,EXTERNAL_LOOP
                DJNZ    R2,ONE_DIGIT_SHOWING
                JNB     MINUTES_CHANGED,GET_AWAY_FROM_ME
                CLR     MINUTES_CHANGED
                LCALL   LET_S_COMPARE_TIME
GET_AWAY_FROM_ME:
                LJMP    LOOPED_INDICATION_ROUTINE
;************************************************

;************** INTERRUPT FROM TIMER ************

TIMES_UP:

                CLR     TCON.4
                MOV     TL0,#LOW(NOT(CONSTANTA))
                MOV     TH0,#HIGH(NOT(CONSTANTA))
                SETB    TCON.4

                PUSH    ACC
                MOV     A,FIFTIES
                ADD     A,#001H
                DA      A
                MOV     FIFTIES,A
                CJNE    A,#005H,NO_TOUCH_POINT
                CLR     FLASH_POINT
NO_TOUCH_POINT:
                CJNE    A,#020H,ALL_S_OVER
                MOV     FIFTIES,#000H
                SETB    FLASH_POINT

                MOV     A,SECONDS
                ADD     A,#001H
                DA      A
                MOV     SECONDS,A
                CJNE    A,YET_CRY_OR_NOT,WELL
                CLR     SIGNAL_LINE
                CLR     DESPERATE_CRY
WELL:
                CJNE    A,#060H,ESCAPE_FROM_HERE
                MOV     SECONDS,#000H
                SETB    MINUTES_CHANGED

                MOV     A,MINUTES
                ADD     A,#001H
                DA      A
                MOV     MINUTES,A
                CJNE    A,#060H,ESCAPE_FROM_HERE
                MOV     MINUTES,#000H
                SETB    HOURS_CHANGED

                MOV     A,HOURS
                ADD     A,#001H
                DA      A
                MOV     HOURS,A
                CJNE    A,#024H,ESCAPE_FROM_HERE
                MOV     HOURS,#000H
                SETB    DAYS_CHANGED

                MOV     A,DAYS
                INC     A
                MOV     DAYS,A
                CJNE    A,#008H,ESCAPE_FROM_HERE
                MOV     DAYS,#001H

ESCAPE_FROM_HERE:

                JB      SET_DW,OVERJUMP
                SJMP    NORMAL_RELOADING
OVERJUMP:
                JNB     DAYS_CHANGED,ALL_S_OVER
                CLR     DAYS_CHANGED
                LCALL   RELOAD_DAYS_IN_INDIBOXES
                LJMP    ALL_S_OVER
NORMAL_RELOADING:
                JNB     MINUTES_CHANGED,RUN_SPEEDY
                LCALL   RELOAD_MINUTES_IN_INDIBOXES
RUN_SPEEDY:
                JNB     HOURS_CHANGED,ALL_S_OVER
                CLR     HOURS_CHANGED
                LCALL   RELOAD_HOURS_IN_INDIBOXES
ALL_S_OVER:
                POP     ACC
                RETI
;**************************************************


;************** TIME COMPARING ********************

LET_S_COMPARE_TIME:

                PUSH    P3
                PUSH    PSW
                SETB    PSW.3
                LCALL   ADDRESS_OF_NEW_DAY      ;DAY ADDRESS IDENTIFY
                MOV     R4,#NUMBER_OF_SIGNALS_PER_DAY
LOOP_AS_YOU_CAN_SEE:
                LCALL   READING                 ;HOURS READING
                MOV     R3,DATAOUT              ;SAVE FOR PRODUCE SIGNAL RANGE
                LCALL   ADDRESS_INCREMENT       ;MINUTES ADDRESS
                MOV     A,DATAOUT               ;READING RESULT(HOURS)
                ANL     A,#03FH
                CJNE    A,HOURS,COMPARING_FAILED
                LCALL   READING                 ;MINUTES READING
                MOV     A,DATAOUT
                ANL     A,#07FH
                CJNE    A,MINUTES,COMPARING_FAILED

                SETB    SIGNAL_LINE             ;SIGNAL STARTED
                SETB    DESPERATE_CRY           ;SIGNAL FLAG
                LCALL   DURATION_SEPARATE
                MOV     YET_CRY_OR_NOT,A
                INC     YET_CRY_OR_NOT

                SJMP    YES_IT_FINISHED
COMPARING_FAILED:
                DJNZ    R4,IN_THIS_DAY_TABLEM1  ;IF TABLE FULL,NO GO TO NEXT
                SJMP    YES_IT_FINISHED         ;NEXT HOURS ADDRESS
IN_THIS_DAY_TABLEM1:
                LCALL   ADDRESS_INCREMENT
                SJMP    LOOP_AS_YOU_CAN_SEE

YES_IT_FINISHED:
                POP     PSW
                POP     P3
                RET
;***********************************************

KEYBOARD_OVERDRIVE:

                PUSH    ACC
                PUSH    P3
                PUSH    PSW
                SETB    PSW.4
                CLR     PSW.3

;KEY IDENTIFY ROUTINE
                MOV     A,#07FH
                MOV     R2,#004H
                SETB    FIRST_PRESS
SCANNING_LOOP:
                MOV     P3,#0FCH
                ANL     P3,A
                JNB     DESPERATE_CRY,KEEPZERO_M1
                SETB    SIGNAL_LINE
KEEPZERO_M1:
                JNB     RETURN_KEYS_LINE,I_TAKE_IT
                CJNE    A,#07FH,ONE_SHIFT_PLEASE
                RR      A
ONE_SHIFT_PLEASE:
                RR      A
                DJNZ    R2,SCANNING_LOOP
KEY_NOT_PRESSED:
                CLR     CONTACT
                LJMP    KEYBOARD_SERVICED
I_TAKE_IT:
                JNB     FIRST_PRESS,PRESS_NO_FST
                MOV     BUFFER,R2
                CLR     FIRST_PRESS
                SJMP    SCANNING_LOOP
PRESS_NO_FST:
                MOV     A,R2
                CJNE    A,BUFFER,KEY_NOT_PRESSED

                SETB    CONTACT
                CLR     DARK_OF_THE_SUN
                MOV     06H,#0FFH               ;REGISTER R6 IN BANK0
;IN R2 - NUMBER OF KEY (IN BACK ORDER)
;KEY IDENTIFY COMPLETED

KEYBOARD_SERVICE:
                JB      INVALID,FAIL
                JNB     CLR_FLAG,DESTROYERR
                cjne    R2,#1,FAIL1
                SJMP    DESTROYERR
FAIL1:
                cjne    R2,#2,FAIL
                SJMP    DESTROYERR
FAIL:
                LJMP    KEYBOARD_SERVICED
DESTROYERR:

                CJNE    R2,#002H,NEXT_1
                JB      CLR_FLAG,NEXT_A
                LJMP    INVERSION_SET_FLAG
                SJMP    NEXT_1
NEXT_A:
                CLR     CLR_FLAG
                LJMP    MODE_00
NEXT_1:
                CJNE    R2,#001H,NEXT_2
                LJMP    DESTROY_BRAIN
NEXT_2:
                JNB     SET_FLAG,WORKING_MODE
                LJMP    PROGRAMMING_MODE
;****************************************************
WORKING_MODE:
;NORMAL OPERATIONS WITH TIME
                CLR     CLR_FLAG
                CJNE    R2,#003H,PRESSED_MODEKEYM1
                SJMP    PRESSED_SETTINGM1
PRESSED_MODEKEYM1:
                MOV     A,MODE
                ADD     A,#001H
                MOV     MODE,A
;IN A - CODE OF MODE
                CJNE    A,#004,NOT_MAINM1
                MOV     MODE,#000H              ;MAIN MODE SET
                MOV     SECONDS,#000H
                MOV     FIFTIES,#000H
                CLR     SET_MIN
                LJMP    KEYBOARD_SERVICED
NOT_MAINM1:
                CJNE    A,#001,NOT_SETDAYM1
                SETB    SET_DW
                LCALL   RELOAD_DAYS_IN_INDIBOXES
                LJMP    KEYBOARD_SERVICED
NOT_SETDAYM1:
                CJNE    A,#002H,NOT_SETHRM1
                SETB    SET_HOUR
                CLR     SET_DW
                LCALL   RELOAD_HOURS_IN_INDIBOXES
                LCALL   RELOAD_MINUTES_IN_INDIBOXES
                LJMP    KEYBOARD_SERVICED
NOT_SETHRM1:    ;SET MINUTE MODE
                SETB    SET_MIN
                CLR     SET_HOUR
                LJMP    KEYBOARD_SERVICED
;MODE SHIFT KEY SERVICE COMPLETED

PRESSED_SETTINGM1:
                MOV     A,MODE
                CJNE    A,#001H,NOT_SETDWM2
                MOV     A,DAYS
                ADD     A,#001H
                MOV     DAYS,A
                CJNE    A,#008H,IN_WEEKM1
                MOV     DAYS,#001H
IN_WEEKM1:
                LCALL   RELOAD_DAYS_IN_INDIBOXES
                LJMP    KEYBOARD_SERVICED
NOT_SETDWM2:
                CJNE    A,#002H,NOT_SETHRM2
                MOV     A,HOURS
                ADD     A,#001H
                DA      A
                MOV     HOURS,A
                CJNE    A,#024H,IN_DAYM1
                MOV     HOURS,#000H
IN_DAYM1:
                LCALL   RELOAD_HOURS_IN_INDIBOXES
                LJMP    KEYBOARD_SERVICED
NOT_SETHRM2:
                CJNE    A,#003H,TO_HONEY
                MOV     A,MINUTES
                ADD     A,#001H
                DA      A
                MOV     MINUTES,A
                CJNE    A,#060H,IN_HOURM1
                MOV     MINUTES,#000H
IN_HOURM1:
                LCALL   RELOAD_MINUTES_IN_INDIBOXES
TO_HONEY:
                LJMP    KEYBOARD_SERVICED
;NORMAL OPERATIONS WITH TIME COMPLETED
;*******************************************************

;************** KEYS WORKS IN PROGRAMMING MODE *********
PROGRAMMING_MODE:
                CJNE    R2,#003,MODEKEYPRESSED
                LJMP    SETTINGKEYPRESSED
MODEKEYPRESSED:
                JNB     FIRST,NOT_VIRGIN
                MOV     DAYS,#001H
                SJMP    MODE_00
NOT_VIRGIN:
                MOV     A,MODE
                ADD     A,#001H
                MOV     MODE,A
                CJNE    A,#004H,NOT_SETDWSMALLJUMP
                SJMP    MODE_00
NOT_SETDWSMALLJUMP:
                LJMP    NOT_SETDWM3
MODE_00:

                MOV     MODE,#000H
                SETB    SET_DW
                LCALL   RELOAD_DAYS_IN_INDIBOXES
                JNB     FIRST,NO_FIRST
                CLR     FIRST
                LJMP    KEYBOARD_SERVICED

;INSERTING OF TIME RANGE INTO FREE PLASES OF MINUTES & HOURS
NO_FIRST:
                MOV     A,DURATION
                SWAP    A                       ;o210 oooo
                RL      A                       ;210o oooo
                MOV     BUFFER,A
                ANL     BUFFER,#080H            ;IN BUFFER  2ooo oooo-READY
                ANL     A,#060H                 ;IN A       o10o oooo
                RL      A                       ;IN A       10oo oooo-READY
                ORL     HOURS,A                 ;10XX XXXX - FULL READY
                MOV     A,BUFFER
                ORL     MINUTES,A               ;2XXX XXXX - FULL READY
;INSERTING COMPLETED
                MOV     A,S_MINUTES
                CJNE    A,MINUTES,NEED_FOR_WRITING
                MOV     A,S_HOURS
                CJNE    A,HOURS,NEED_FOR_WRITING
                AJMP    KEYBOARD_SERVICED

NEED_FOR_WRITING:
;ADDRESS WAS DOUBLE INCREMENTED IN LAST READING
;IT NEED FOR 2xDEC NOW
                LCALL   ADDRESS_DECREMENT
                LCALL   ADDRESS_DECREMENT
                MOV     DATAOUT,HOURS
                MOV     P3,#000H
                mov     P1,#0
                mov     b,DATAOUT
                push    B
                LCALL   WRITING
                LCALL   EXTRA_DELAY             ;WRITE HOURS
                LCALL   READING
                clr     C
                pop     b
                mov     a,dataout
                subb    a,b
                JNZ     NEED_FOR_GPF
                sjmp    NEXTAR
NEED_FOR_GPF:
                LJMP    GPF

NEXTAR:
                LCALL   EXTRA_DELAY
HOURS_FINISHED:
                LCALL   ADDRESS_INCREMENT       ;MINUTES ADDRESS
                MOV     DATAOUT,MINUTES
                mov     B,DATAOUT
                push    B
                LCALL   WRITING                 ;WRITE MINUTES
                LCALL   EXTRA_DELAY
                LCALL   READING
                clr     C
                pop     B
                mov     a,dataout
                subb    a,b
                JNZ     NEED_FOR_GPF

MINUTES_FINISHED:
                LCALL   ADDRESS_INCREMENT       ;NEXT HOURS ADDRESS
                LJMP    KEYBOARD_SERVICED
;MODE 00 OPERATIONS COMPLETED

NOT_SETDWM3:
                CJNE    A,#001H,NOT_SETHOURSM2

;************** SET HOURS IM PROGRAMMING GLOBAL MODE

                MOV     A,DAYS
                CJNE    A,LAST,DAY_DETECT
                SJMP    DAY_OLD
DAY_DETECT:
                LCALL   ADDRESS_OF_NEW_DAY
                MOV     LAST,DAYS
                MOV     LIMITER,#NUMBER_OF_SIGNALS_PER_DAY
DAY_OLD:
                DJNZ    LIMITER,READY_FOR_READING
                SJMP    DAY_DETECT
READY_FOR_READING:
                LCALL   READING
                MOV     S_HOURS,DATAOUT
                MOV     HOURS,DATAOUT
                ANL     HOURS,#03FH                     ;DIG 2bits OF RANGE
                MOV     R3,DATAOUT                      ;FOR SEPARATE RANGE
                LCALL   ADDRESS_INCREMENT               ;ADDRESS MINUTE
                LCALL   READING
                MOV     S_MINUTES,DATAOUT
                MOV     MINUTES,DATAOUT
                ANL     MINUTES,#07FH                   ;DIG 1bit OF RANGE
                LCALL   ADDRESS_INCREMENT               ;ADDRESS NEXT HOURS
                LCALL   DURATION_SEPARATE
                MOV     DURATION,A
                MOV     A,HOURS
                CJNE    A,#03FH,NOT_EMPTY
                MOV     HOURS,#0FFH
                SETB    HOURS_EMPTY
NOT_EMPTY:
                MOV     A,MINUTES
                CJNE    A,#07FH,NOT_EMPTYMNXT
                MOV     MINUTES,#0FFH
                SETB    MINUTES_EMPTY
NOT_EMPTYMNXT:
                LCALL   RELOAD_HOURS_IN_INDIBOXES
                LCALL   RELOAD_MINUTES_IN_INDIBOXES
                CLR     SET_DW
                CLR     SET_MIN
                SETB    SET_HOUR
                LJMP    KEYBOARD_SERVICED
;********************************************************

NOT_SETHOURSM2:
                CJNE    A,#002,SHOW_RANGE
                SETB    SET_MIN
                CLR     SET_HOUR
                LJMP    KEYBOARD_SERVICED
SHOW_RANGE:
                CLR     SET_MIN
                LCALL   RELOAD_DURATION
                LJMP    KEYBOARD_SERVICED

;********************************************************

SETTINGKEYPRESSED:
                MOV     A,MODE
                CJNE    A,#000H,NOTMODE00NOW
                MOV     LAST,#0FFH
                MOV     A,DAYS
                INC     A
                MOV     DAYS,A
                CJNE    A,#008H,DAY_OLDM1
                MOV     DAYS,#001H
DAY_OLDM1:
                MOV     IND0,DAYS
                LJMP    KEYBOARD_SERVICED
NOTMODE00NOW:
                CJNE    A,#001H,NOTMODE01NOW
                MOV     A,HOURS
                ADD     A,#001H
                JBC     HOURS_EMPTY,NO_CORRECTHR
                DA      A
NO_CORRECTHR:
                MOV     HOURS,A
                CJNE    A,#024H,IN_DAYXM0
                MOV     HOURS,#000H
IN_DAYXM0:
                LCALL   RELOAD_HOURS_IN_INDIBOXES
                LJMP    KEYBOARD_SERVICED
NOTMODE01NOW:
                CJNE    A,#002H,NOTMODE02NOW
                MOV     A,MINUTES
                ADD     A,#001H
                JBC     MINUTES_EMPTY,NO_CORRECTMN
                DA      A
NO_CORRECTMN:
                MOV     MINUTES,A
                CJNE    A,#060H,IN_HOURXM0
                MOV     MINUTES,#000H
IN_HOURXM0:
                LCALL   RELOAD_MINUTES_IN_INDIBOXES
                LJMP    KEYBOARD_SERVICED
NOTMODE02NOW:
                MOV     A,DURATION
                ADD     A,#001H
                MOV     DURATION,A
                CJNE    A,#008,IN_EIGHT
                MOV     DURATION,#000H
IN_EIGHT:
                LCALL   RELOAD_DURATION
                LJMP    KEYBOARD_SERVICED
;*********************************************************

;************** GLOBAL MODE SHIFT ROUTINE ****************
INVERSION_SET_FLAG:
                MOV     A,MODE
                JZ      GLOBAL_MODE_CHANGE_ENABLE
                AJMP    KEYBOARD_SERVICED
GLOBAL_MODE_CHANGE_ENABLE:
                CPL     SET_FLAG
                CLR     CLR_FLAG
                JB      SET_FLAG,SET_ACTIVED
                SETB    TCON.4
                MOV     MODE,#000H
                MOV     MINUTES,#000H
                MOV     HOURS,#000H
                MOV     DAYS,#001H
                CLR     SET_MIN
                CLR     SET_HOUR
                CLR     SET_DW
                LCALL   RELOAD_HOURS_IN_INDIBOXES
                LCALL   RELOAD_MINUTES_IN_INDIBOXES
                LJMP    KEYBOARD_SERVICED
SET_ACTIVED:
                CLR     TCON.4
                CLR     FLASH_POINT
                SETB    FIRST
                MOV     LAST,#0FFH
                LJMP    MODEKEYPRESSED
;**********************************************************

;************** CLEAR MEMORY ROUTINE **********************
DESTROY_BRAIN:
                JNB     SET_FLAG,EXITCLR
                MOV     A,MODE
                JNZ     EXITCLR
                JB      CLR_FLAG,ERASE_ENABLED
                SETB    CLR_FLAG
                MOV     IND3,#12H ;C
                MOV     IND2,#06H ;
                MOV     IND1,#0EH ;
                MOV     IND0,#12H ;
EXITCLR:
                ljmp    KEYBOARD_SERVICED
ERASE_ENABLED:

                MOV     HOURS,#0FFH
                MOV     MINUTES,#0FFH
                SETB    HOURS_EMPTY
                SETB    MINUTES_EMPTY
                MOV     DURATION,#007H
                MOV     MODE,#001H
                CLR     CLR_FLAG

                mov     P1,#0
                MOV     BLOCK2K,#FIRSTBLOCK
                lcall   EXTRA_DELAY
                LCALL   CLRBLOCK
VOZVRAT:
                mov     DATAVIZOR,#0
                MOV     BLOCK2K,#FIRSTBLOCK
                ljmp    MODE_00

ERRORKS:
                dec     sp
                dec     sp
;General Protection Fault (Exception 13)
GPF:                              ;  _        _   _
                mov     IND3,#0Dh ; (_)|/|(o<ͳ!
                mov     IND2,#13h
                mov     IND1,#0Eh
                mov     IND0,#0Ah
                setb    INVALID
                ljmp    KEYBOARD_SERVICED


CLRBLOCK:
                MOV     DATAVIZOR,#0
                mov     7Fh,#2
                MOV     7Eh,#0
CLR1:
                mov     dataout,#0FFh
                LCALL   WRITING
                lcall   EXTRA_DELAY
                lcall   READING
                mov     a,DATAOUT
                inc     a
                jnz     ERRORKS
                lcall   ADDRESS_INCREMENT
                DJNZ    7Eh,CLR1
                DJNZ    7Fh,CLR1
                RET

;**********************************************************

KEYBOARD_SERVICED:
                POP    PSW
                POP    P3
                POP    ACC
                RET
;**********************************************
;==============================================
;**********************************************

RELOAD_HOURS_IN_INDIBOXES:
                MOV    A,HOURS
                MOV    IND2,A
                ANL    IND2,#00FH
                SWAP   A
                ANL    A,#00FH
                CJNE   A,#000H,D4TH_LIGHT
                MOV    IND3,#010H
                SJMP   HOURS_RELOADED
D4TH_LIGHT:

                MOV    IND3,A
HOURS_RELOADED:
                RET
;**********************************************

RELOAD_MINUTES_IN_INDIBOXES:
                MOV    A,MINUTES
                MOV    IND0,A
                SWAP   A
                MOV    IND1,A
                ANL    IND0,#00FH
                ANL    IND1,#00FH
                RET
;**********************************************

RELOAD_DURATION:
                MOV     IND3,#00BH             ;D
                MOV     IND2,#012H             ;C
                MOV     IND1,#010H             ;DARK
                MOV     IND0,DURATION
                INC     IND0
                RET

;*********************************************
RELOAD_DAYS_IN_INDIBOXES:
                MOV       IND3,#00EH
                JNB       SET_FLAG,SHOW_CLOCK_MODE
                MOV       IND2,#011H
                SJMP      DAYS_RELOADED
SHOW_CLOCK_MODE:
                MOV       IND2,#004H
DAYS_RELOADED:
                MOV       IND1,#00BH
                MOV       IND0,DAYS
                RET
;*********************************************

;************** ADDRESS INCREMENT ROUTINE ******
ADDRESS_INCREMENT:
                MOV     A,DATAVIZOR
                INC     A
                JNZ     IN_FIRST_BLOCK2K
                MOV     BLOCK2K,#SECONDBLOCK
IN_FIRST_BLOCK2K:
                MOV     DATAVIZOR,A
                RET
;************** COMPLETED **********************

;************** ADDRESS IDENTIFY ROUTINE *******
ADDRESS_OF_NEW_DAY:
                MOV     A,DAYS
                DEC     A
                MOV     B,#002H
                MUL     AB
                MOV     B,#36
                MUL     AB
                MOV     DATAVIZOR,A                  ;DATA ADDRESS
                MOV     A,B                          ;HIGH BYTE  0000 000X
                RL      A                            ; 0000 00X0
                RL      A                            ; 0000 0X00
                MOV     BLOCK2K,A                    ;SLAVE ADDRESS
                RET
;************** COMPLETED **********************

;************** WAITING ************************
EXTRA_DELAY:
                PUSH    03H
                PUSH    04H
                MOV     03H,#0FFH
DEL_EX:         MOV     04H,#0FFH
DEL_IN:         DJNZ    04H,DEL_IN
                DJNZ    03H,DEL_EX
                POP     04H
                POP     03H
                RET
;*************************************************

;************** ADDRESS DECREMENT ROUTINE ******
ADDRESS_DECREMENT:
                MOV     A,DATAVIZOR
                DEC     A
                JNZ     IN_SECOND_2K
                MOV     BLOCK2K,#FIRSTBLOCK
IN_SECOND_2K:
                MOV     DATAVIZOR,A
                RET
;************** COMPLETED ***********************

;************** TIME RANGE SEPARATE ROUTINE *****
DURATION_SEPARATE:
                MOV     A,R3                    ;hours & 2bits range
                ANL     A,#0C0H                 ;10oo oooo
                RR      A                       ;o10o oooo
                MOV     YET_CRY_OR_NOT,A
                MOV     A,DATAOUT
                ANL     A,#080H                 ;2ooo oooo
                ORL     A,YET_CRY_OR_NOT        ;210o oooo
                SWAP    A                       ;oooo 210o
                RR      A                       ;oooo o210
                RET
;*************** COMPLETED ***********************


SEGMENTIC_CODES_ADDRESS:

DB 0BEH,030H,0DCH,0F4H,072H,0E6H,0EEH,0B0H,0FEH,0F6H,0FAH,0FCH,076H,07AH

;   0    1    2    3    4    5    6    7    8    9    A    D    y    H
;                                                    00AH 00BH 00CH 00DH

DB 0DAH,040H,000H,0BAH,08EH,0CEh

;   P    -   DARK rusP  C    E
;  00EH 00FH 010H 011H 012H 013h

        ;INTERFACE WITH TWO-LINES EEPROM

;************** ONE BYTE WRITING ROUTINE ******

WRITING:        PUSH    PSW
                SETB    PSW.4
                SETB    PSW.3
                ACALL   START_BIT
                MOV     A,#SLV_ADDR
                MOV     R7,#04H
                ACALL   SHFTO
                MOV     A,BLOCK2K
                MOV     R7,#03H
                ACALL   SHFTO
                CLR     A
                MOV     R7,#01H
                ACALL   SHFTO
                ACALL   SLAVE_ACK

                MOV     A,DATAVIZOR
                MOV     R7,#08H
                ACALL   SHFTO
                ACALL   SLAVE_ACK
                MOV     A,DATAOUT
                MOV     R7,#08H
                ACALL   SHFTO

                ACALL   SLAVE_ACK
                ACALL   STOP_BIT
;                ACALL   ACK_POL
                POP     PSW
                RET
;**************************************

;************** READING ROUTINE ********

READING:
                PUSH    PSW
                SETB    PSW.3
                SETB    PSW.4
                ACALL   START_BIT

                MOV     A,#SLV_ADDR
                MOV     R7,#04H
                ACALL   SHFTO
                MOV     A,BLOCK2K
                MOV     R7,#03H
                ACALL   SHFTO
                MOV     A,#00H
                MOV     R7,#01H
                ACALL   SHFTO
                ACALL   SLAVE_ACK

                MOV     A,DATAVIZOR
                MOV     R7,#08H
                ACALL   SHFTO
                ACALL   SLAVE_ACK

                ACALL   START_BIT

                MOV     A,#SLV_ADDR
                MOV     R7,#04H
                ACALL   SHFTO
                MOV     A,BLOCK2K
                MOV     R7,#03H
                ACALL   SHFTO
                MOV     A,#01H
                MOV     R7,#01H
                ACALL   SHFTO
                ACALL   SLAVE_ACK

                MOV     R7,#08H
CLOCK8:         SETB    SCL
                NOP
                MOV     C,SDA
                CLR     SCL
                MOV     A,DATAOUT
                RRC     A
                MOV     DATAOUT,A
                DJNZ    R7,CLOCK8
                ACALL   NO_ACK
                ACALL   STOP_BIT
                POP     PSW
                RET
;**************************************

;************* ACK_POL ****************

ACK_POL:        MOV     R3,#40H
ACK_LOOP:       DJNZ    R3,DONE_YET
                SJMP    DN_ACKPOL
DONE_YET:       ACALL   START_BIT
                MOV     A,#ACK_READ
                MOV     R7,#08H
                ACALL   SHFTO
                ACALL   SLAVE_ACK
                JC      ACK_LOOP        ;LOOP IF NOT ACK RCVD
DN_ACKPOL:      ACALL   STOP_BIT
                RET
;***************************************

;************** TRANSMITTING ***********

SHFTO:          CLR     SCL
NXTSHF:         CLR     SCL
                RRC     A
                MOV     SDA,C
                SETB    SCL
                DJNZ    R7,NXTSHF
                RET
;***************************************

;*************** START BIT *************

START_BIT:      SETB    SCL
                NOP
                SETB    SDA
                NOP
                CLR     SDA
                NOP
                CLR     SCL
                RET
;***************************************

;**************** STOP BIT *************

STOP_BIT:       CLR     SDA
                NOP
                SETB    SCL
                NOP
                SETB    SDA
                RET
;***************************************

;*********** SLAVE ACKNOWLEGE **********

SLAVE_ACK:      NOP
                NOP
                CLR     SCL
                NOP
                SETB    SDA
                NOP
                NOP
                SETB    SCL
                NOP
                NOP
                NOP
                MOV     C,SDA
                CLR     SCL
                RET
;***************************************

;********** MASTER ACKNOWLEGE **********

MSTR_ACK:
                CLR     SCL
                NOP
                CLR     SDA
                NOP
                NOP
                SETB    SCL
                NOP
                CLR     SCL
                NOP
                SETB    SDA
                RET
;***************************************

;*********** NO ACKNOWLEGE *************

NO_ACK:         SETB    SDA
                NOP
                SETB    SCL
                NOP
                CLR     SCL
                RET
;***************************************


;Copyrights (C) By Corpseborn
;Designed of spring 1999 Year
;Cracked by SkyDragon (C) 1999


END